# %%
# This script was written to read the data in the folder data/dual_pandas_2
# Computation and estimation of the position deviation when subject to a 2kg weight (step force)
# With various control gains for the endpoint impedance controllers
%matplotlib qt
import os
import csv
import shutil
import time

from copy import deepcopy
from bagpy import bagreader
import numpy as np
from scipy import signal
from skimage.restoration import denoise_tv_chambolle
import matplotlib.pyplot as plt
from matplotlib import ticker as tck
from matplotlib import rcParams
from matplotlib.lines import Line2D
from tqdm import tqdm # for progression bar

from pynocchio import RobotWrapper
from pinocchio import SE3, Quaternion, log6

# %% MACROS

# this set is erroneous
# bag_directory = "data/dual_pandas_2/"
# bag_name_list = ["dual_pandas_config_1_2023-08-23-14-22-13.bag",
#                  "dual_pandas_config_1_p2_red_2023-08-23-14-25-13.bag",
#                  "dual_pandas_config_1_p2_red_p1_red_2023-08-23-14-30-30.bag",
#                  "dual_pandas_config_1_p2_red_p1_aug_2023-08-23-14-32-20.bag",
#                  "dual_pandas_config_1_p2_aug_p1_red_2023-08-23-14-34-26.bag"]
# KP_gain_list = np.array([[500, 500],
#                          [500, 250],
#                          [250, 250],
#                          [750, 250],
#                          [250, 750]])
# edges_idx_list = np.array([[1175, 1825],
#                            [1920, 2820],
#                            [1480, 2420],
#                            [1060, 2030],
#                            [1020, 1880]])
bag_directories = []
bag_names_list = []
edges_idxs_list = []
# QUASI NEUTRAL CONF (QUASI SYMMETRIC)
bag_directories.append("data/dual_pandas_corrected/config_neutral/")
bag_names_list.append(["dual_pandas_Kp1_250_Kp2_250_2023-08-24-15-13-19.bag",
                       "dual_pandas_Kp1_250_Kp2_500_2023-08-24-15-17-55.bag",
                       "dual_pandas_Kp1_250_Kp2_750_2023-08-24-15-19-17.bag",
                       "dual_pandas_Kp1_500_Kp2_250_2023-08-24-15-15-04.bag",
                       "dual_pandas_Kp1_500_Kp2_500_2023-08-24-15-16-30.bag",
                       "dual_pandas_Kp1_750_Kp2_250_2023-08-24-15-20-23.bag"])
edges_idxs_list.append( 10*np.array([[117,191],[102,194],[79,174],[119,205],[108,192],[88,187]]) )
bag_directories.append("data/dual_pandas_corrected/config_2/")
bag_names_list.append(["dual_pandas_Kp1_250_Kp2_250_2023-08-24-15-30-57.bag",
                       "dual_pandas_Kp1_250_Kp2_500_2023-08-24-15-26-15.bag",
                       "dual_pandas_Kp1_250_Kp2_750_2023-08-24-15-27-14.bag",
                       "dual_pandas_Kp1_500_Kp2_250_2023-08-24-15-28-29.bag",
                       "dual_pandas_Kp1_500_Kp2_500_2023-08-24-15-25-14.bag",
                       "dual_pandas_Kp1_750_Kp2_250_2023-08-24-15-29-40.bag"])
edges_idxs_list.append(np.array([[800,1760],[665,1665],[920,1865],[840,1820],[925,1780],[1020,2020]]))
bag_directories.append("data/dual_pandas_corrected/config_3/")
bag_names_list.append(["dual_pandas_Kp1_250_Kp2_250_2023-08-24-15-40-45.bag",
                       "dual_pandas_Kp1_250_Kp2_500_2023-08-24-15-44-57.bag",
                       "dual_pandas_Kp1_250_Kp2_750_2023-08-24-15-39-46.bag",
                       "dual_pandas_Kp1_500_Kp2_250_2023-08-24-15-44-03.bag",
                       "dual_pandas_Kp1_500_Kp2_500_2023-08-24-15-41-56.bag",
                       "dual_pandas_Kp1_750_Kp2_250_2023-08-24-15-43-00.bag"])
edges_idxs_list.append(np.array([[1040,2040],[810,1805],[1050,2040],[600,1600],[720,1700],[740,1780]]))

KP_gain_list = np.array([[250,250],[250,500],[250,750],[500,250],[500,500],[750,250]])
arm_ids = ["panda_1",
           "panda_2"]
topics = ["joint_states", 
          "F_ext",
          "desired_cartesian_pose"]

color_list = ['tab:blue', 'tab:orange', 'tab:green', 'tab:red', 'tab:purple', 'tab:brown', 'tab:olive']

g = 9.81

WEB_VISUALIZER_ON = False
CHECK_RECONSTRUCTED_FORCES_ON = False
CHECK_ALL_AXIS_DEVIATION_ON = False
CHECK_NORM_DEVIATION_ON = False
AXIS = ['x', 'y', 'z']

# %% FUNCTIONS

def get_data_from_rosbag(bag_name, topics, arm_id, verbose=False):
    bag_file = bagreader(bag_name, verbose=verbose)
    topic_list = [*bag_file.topics]
    # indexes of the desired topics in the actual topic list
    idxs = [i for des_topic in topics for i, topic in enumerate(topic_list) if des_topic in topic and arm_id in topic]
    csv_names = [bag_file.message_by_topic(topic_list[idx]) for idx in idxs]
    raw_data = [np.genfromtxt( ("\t".join(i) for i in csv.reader(open(csv_name))), delimiter="\t", names=True ) for csv_name in csv_names]
    # the message_by_topic function creates csv files inside the folder generated by the bagreader, we delete them after getting the data 
    shutil.rmtree(os.path.dirname(csv_names[0])) 
    return dict(zip(topics, raw_data))

def get_ft_data(raw_ft_data):
    headers = raw_ft_data.dtype.names
    time_idx = [i for i, header in enumerate(headers) if header.lower() == 'time'][0]
    force_idx = [i for i, header in enumerate(headers) for force_name in ['wrenchforcex', 'wrenchforcey', 'wrenchforcez'] if header.lower() == force_name]
    torque_idx = [i for i, header in enumerate(headers) for torque_name in ['wrenchtorquex', 'wrenchtorquey', 'wrenchtorquez'] if header.lower() == torque_name]
    
    raw_time = np.array([np.array(data.tolist())[time_idx] for data in raw_ft_data]).T
    raw_force = np.array([np.array(data.tolist())[force_idx] for data in raw_ft_data]).T
    raw_torque = np.array([np.array(data.tolist())[torque_idx] for data in raw_ft_data]).T

    return dict(zip(['t', 'f_ext', 'tau_ext'], [raw_time, raw_force, raw_torque]))

def get_joint_data(raw_joint_data, nb_joints):
    headers = raw_joint_data.dtype.names
    time_idx = [i for i, header in enumerate(headers) if header.lower() == 'time'][0]
    q_idx = [i for i, header in enumerate(headers) for joint_position_name in ['position_' + str(i) for i in range(nb_joints+1)] if header.lower() == joint_position_name]
    dq_idx = [i for i, header in enumerate(headers) for joint_velocity_name in ['velocity_' + str(i) for i in range(nb_joints+1)] if header.lower() == joint_velocity_name]
    tau_idx = [i for i, header in enumerate(headers) for joint_effort_name in ['effort_' + str(i) for i in range(nb_joints+1)] if header.lower() == joint_effort_name]
    
    raw_time = np.array([np.array(data.tolist())[time_idx] for data in raw_joint_data]).T
    raw_q = np.array([np.array(data.tolist())[q_idx] for data in raw_joint_data]).T
    raw_dq = np.array([np.array(data.tolist())[dq_idx] for data in raw_joint_data]).T
    raw_tau = np.array([np.array(data.tolist())[tau_idx] for data in raw_joint_data]).T

    return dict(zip(['t', 'q', 'dq', 'tau'], [raw_time, raw_q, raw_dq, raw_tau]))

def get_desired_pose(raw_desired_pose_data):
    headers = raw_desired_pose_data.dtype.names
    time_idx = [i for i, header in enumerate(headers) if header.lower() == 'time'][0]
    position_idx = [i for i, header in enumerate(headers) for position_name in ['posepositionx', 'posepositiony', 'posepositionz'] if header.lower() == position_name]
    orientation_idx = [i for i, header in enumerate(headers) for quaternion_name in ['poseorientationx', 'poseorientationy', 'poseorientationz', 'poseorientationw'] if header.lower() == quaternion_name]
    
    raw_time = np.array([np.array(data.tolist())[time_idx] for data in raw_desired_pose_data]).T
    raw_position = np.array([np.array(data.tolist())[position_idx] for data in raw_desired_pose_data]).T
    raw_orientation = np.array([np.array(data.tolist())[orientation_idx] for data in raw_desired_pose_data]).T

    return dict(zip(['t', 'des_position', 'des_orientation'], [raw_time, raw_position, raw_orientation]))

def interpolate(extracted_data, step=1e-2, t=None):
    # building time array, if none is provided
    max_t0 = -np.inf
    min_tend = np.inf
    for data in extracted_data.values():
        if max_t0 < data['t'][0]:
            max_t0 = data['t'][0]
        if min_tend > data['t'][-1]:
            min_tend = data['t'][-1]
    if t is not None:
        t = t + max_t0
    else:
        t = np.arange(max_t0, min_tend, step)
    # interpolating data on the built time array
    interp_data = {}
    for topic, data in extracted_data.items():
        if "joint_states" in topic:
            q = np.array([np.interp(t, data['t'], qi) for qi in data['q']])
            dq = np.array([np.interp(t, data['t'], dqi) for dqi in data['dq']])
            tau = np.array([np.interp(t, data['t'], taui) for taui in data['tau']])
            interp_data[topic] = dict(zip(['q', 'dq', 'tau'], [q, dq, tau]))
        elif  "netft_data" in topic or "external_force" in topic or 'F_ext' in topic:
            force = np.array([np.interp(t, data['t'], fi) for fi in data['f_ext']])
            torque = np.array([np.interp(t, data['t'], tqi) for tqi in data['tau_ext']])
            interp_data[topic] = dict(zip(['f_ext', 'tau_ext'], [force, torque]))
        elif  "desired_cartesian_pose" in topic:
            position = np.array([np.interp(t, data['t'], fi) for fi in data['des_position']])
            orientation = np.array([np.interp(t, data['t'], tqi) for tqi in data['des_orientation']])
            interp_data[topic] = dict(zip(['des_position', 'des_orientation'], [position, orientation]))

    t = t - t[0]
    for topic in extracted_data.keys():
        interp_data[topic]['t'] = t

    return interp_data

def compute_servoing_error(data):
    '''
    Compute the servoing error between a desired pose and an actual pose in SE3
    '''
    servoing_error = []
    for pose_i, desired_pose_i in zip(data['pose'], data['desired_pose']):
        adj = np.concatenate( (np.concatenate( (pose_i.rotation, np.zeros((3,3))), axis=1 ),np.concatenate( (np.zeros((3,3)), pose_i.rotation), axis=1 )), axis=0 )
        servoing_error.append( adj @ log6(pose_i.actInv(desired_pose_i)).vector )
    servoing_error = np.array(servoing_error).T
    new_data = deepcopy(data)
    new_data['serv_err'] = servoing_error
    return new_data

def compute_static_error(data, robot_wrapper, KP):
    '''
    Compute the estimated static error, based on the robot model and control, and reconstructed interaction force
    '''
    estimated_pose_deviation = []
    for qi, wrenchi in zip(data['q'].T, data['wrench_rec'].T):
        J = robot_wrapper.jacobian(qi)
        estimated_pose_deviation.append(np.linalg.inv(KP) @ J @ np.linalg.inv(robot_wrapper.mass_matrix(qi)) @ J.T @ wrenchi)
    estimated_pose_deviation = np.array(estimated_pose_deviation).T
    # new_data = deepcopy(data)
    # new_data['est_pose_deviation'] = estimated_pose_deviation
    return estimated_pose_deviation

def compute_coupled_stiffness_matrices(datas, robot_wrappers, KPs):
    '''
    Compute the coupled stiffness matrices for 2 connected robots, based on each robot model and control.
    '''
    nb_samples = datas[list(datas.keys())[0]]['q'].shape[1]
    coupled_stiffness_mat = np.zeros((nb_samples,6,6))
    for p, data in enumerate(datas.items()):
        estimated_pose_deviation = []
        for i, qi in enumerate(data[1]['q'].T):
            J = robot_wrappers[p].jacobian(qi) 
            aM = J @ np.linalg.inv(robot_wrappers[p].mass_matrix(qi)) @ J.T
            coupled_stiffness_mat[i,:,:] += np.linalg.pinv(aM) @ KPs[p]
    return coupled_stiffness_mat

def filter(sig, t, fc=50, order=4):
    '''
    Low pass digital filter with cutoff frequency fc
    '''
    fs = 1/np.mean(np.diff(t)) # sampling frequency
    w = fc / (fs / 2) # normalized frequency
    b, a = signal.butter(order, w, 'low')
    sig_filt = signal.filtfilt(b, a, sig)
    return sig_filt

def get_step_edges(sig:np.array, edges:str='all'):
    '''
    Returns the indexes of edges of a noisy signal with steps.
    The function uses a total variation denoising function from scikit package
    Args:
        sig : 1D signal
        edges: either 'all', 'rising' or 'falling'
    '''
    # denoised normalized signal 
    sig_denoise = denoise_tv_chambolle( (sig - sig.mean())/sig.std(), weight=1 )
    neg_cumsum = -2*np.cumsum(sig_denoise)
    if edges == 'all':
        idxs = np.diff(np.sign(np.diff( neg_cumsum ))).nonzero()[0] + 1
    elif edges == 'rising':
        idxs = (np.diff(np.sign(np.diff( neg_cumsum ))) < 0).nonzero()[0] + 1
    elif edges == 'falling':
        idxs = (np.diff(np.sign(np.diff( neg_cumsum ))) > 0).nonzero()[0] + 1
    else:
        raise ValueError("Unexpected input for argument edges in get_step_edges function. Should be either, 'all', 'rising', or 'falling' ")
    return idxs

# %% MAIN
# pandas models
panda_1 = RobotWrapper(urdf_path="models/urdf/panda_1.urdf", mesh_path="models", robot_name="panda_1", tip="panda_link8")
panda_2 = RobotWrapper(urdf_path="models/urdf/panda_2.urdf", mesh_path="models", robot_name="panda_2", tip="panda_link8", viewer=panda_1.viz.viewer)
pandas = [panda_1, panda_2]

# %% MAIN LOOP
mean_dev_err_robots_middle = []
for sess, bag_name_list in enumerate(tqdm(bag_names_list, desc="Reading experiments in progress...", position=0)):
    bag_directory = bag_directories[sess]
    edges_idx_list = edges_idxs_list[sess]
    for it, bag_name in enumerate(tqdm(bag_name_list, desc="Reading experiments in progress...", leave=False, position=1)):
        # get data from the rosbag
        merged_data = {}
        for p, arm_id in enumerate(arm_ids):
            data = get_data_from_rosbag(bag_directory+bag_name, topics, arm_id)
            raw_joint = get_joint_data(data[topics[0]], nb_joints=7)
            raw_ft = get_ft_data(data[topics[1]])
            raw_desired_pose = get_desired_pose(data[topics[2]])
            if p >= 1: # to synchonise the time vectors of both robots
                data_interpolated = interpolate({topics[0]: raw_joint, topics[1]: raw_ft, topics[2]: raw_desired_pose}, t=merged_data[arm_ids[0]]['t'])
            else:
                data_interpolated = interpolate({topics[0]: raw_joint, topics[1]: raw_ft, topics[2]: raw_desired_pose}, step=1e-2)
            # merged_data.append({**data_interpolated[topics[0]], **data_interpolated[topics[1]], **data_interpolated[topics[2]]})
            merged_data[arm_id] = {**data_interpolated[topics[0]], **data_interpolated[topics[1]], **data_interpolated[topics[2]]}
        del data, raw_joint, raw_ft, raw_desired_pose, data_interpolated
        ######
        # compute SE3 poses
        for panda, arm_id in zip(pandas, arm_ids):
            pose = [SE3(panda.forward(data)) for data in merged_data[arm_id]['q'].T]
            desired_pose = [SE3(Quaternion(np.array(wi)).toRotationMatrix(), np.array(ti)) for ti, wi in zip(merged_data[arm_id]['des_position'].T, merged_data[arm_id]['des_orientation'].T)]
            merged_data[arm_id]['pose'] = pose
            merged_data[arm_id]['desired_pose'] = desired_pose
        ######
        # visualise the geometric experimental data
        if WEB_VISUALIZER_ON:
            for i in range(len(merged_data[arm_ids[0]]['t'])):
                for panda, arm_id in zip(pandas, arm_ids):
                    panda.update_joint_data(q=merged_data[arm_id]['q'][:,i])
                    panda.update_visualisation()
                time.sleep(0.01)
        else: # only plays the intial configuration
            for panda, arm_id in zip(pandas, arm_ids):
                panda.update_joint_data(q=merged_data[arm_id]['q'][:,0])
                panda.update_visualisation() 
        #####
        #Compute the displacement error between desired and measured pose
        for arm_id in arm_ids:
            eps = []
            for pose_i, target_pose_i in zip(merged_data[arm_id]['pose'], merged_data[arm_id]['desired_pose']):
                adj = np.concatenate( (np.concatenate( (pose_i.rotation, np.zeros((3,3))), axis=1 ),np.concatenate( (np.zeros((3,3)), pose_i.rotation), axis=1 )), axis=0 )
                eps.append(adj@log6(pose_i.actInv(target_pose_i)).vector)
            merged_data[arm_id]['deviation'] = np.array(eps).T
        ######
        # Compute the real deviation without the servoing errors
        for p, arm_id in enumerate(arm_ids):
            servoing_error = np.mean(merged_data[arm_id]['deviation'][:,:500], axis=1)
            merged_data[arm_id]['deviation_wo_serr'] = np.array([merged_data[arm_id]['deviation'][i,:] - servoing_error[i] for i in range(len(servoing_error))])
        ######
        # Compute endpoint forces from joint torques (reconstructed force)
        for p, (panda, arm_id) in enumerate(zip(pandas,arm_ids)):
            data = merged_data[arm_id]
            wrench = []
            for q, tau in zip(data['q'].T, data['tau'].T):
                J = panda.jacobian(q)
                wrench.append(np.linalg.pinv(J.T)@tau)
            merged_data[arm_id]['wrench_rec'] = np.array(wrench).T  
            merged_data[arm_id]['wrench_rec_wo_serr'] = np.array([wrench_i - np.mean(wrench_i[:500]) for wrench_i in merged_data[arm_id]['wrench_rec']])   
        # fig, ax = plt.subplots(1,1)
        # ax.plot(merged_data[arm_id]['wrench_rec_wo_serr'][2,:])
        # ###### THIS PART IS NOT ROBUST ENOUGH
        # # Getting the edges of the first step achieved with the weight on the z axis
        # rising_edges_idx = []
        # falling_edges_idx = []
        # len_edges = []
        # for p, arm_id in enumerate(arm_ids):
        #     fz_filt = filter(merged_data[arm_id]['wrench_rec'][2,:], merged_data[arm_id]['t'], fc=50, order=4)
        #     rising_edges_idx.append(get_step_edges(fz_filt, edges='rising'))
        #     falling_edges_idx.append(get_step_edges(fz_filt, edges='falling'))
        #     len_edges.append([len(rising_edges_idx[-1]), len(falling_edges_idx[-1])])
        # len_edges = np.array(len_edges)
        # # the edges detected that are too close to each other are deleted 
        # # when too much edges are detected (might be duplicates from oscillations)
        # if (len_edges[0,0] != len_edges[1,0]):
        #     print("The number of rising edges detected for both robot are different")
        #     if len_edges[0,0] > len_edges[1,0]:
        #         min_diff_idx = np.argmin(np.diff(rising_edges_idx[0]))
        #         # look for the closest rising edges idx witht the other robot
        #         max_diff_idx = np.argmax([rising_edges_idx[0][min_diff_idx+ii] - rising_edges_idx[1][min_diff_idx] for ii in range(2)]) + min_diff_idx
        #         rising_edges_idx[0] = np.delete(rising_edges_idx[0], max_diff_idx)
        #     else:
        #         min_diff_idx = np.argmin(np.diff(rising_edges_idx[1]))
        #         # look for the furthest rising edges idx with the other robot
        #         max_diff_idx = np.argmax([rising_edges_idx[1][min_diff_idx+ii] - rising_edges_idx[0][min_diff_idx] for ii in range(2)]) + min_diff_idx
        #         rising_edges_idx[1] = np.delete(rising_edges_idx[1], max_diff_idx)
        # if (len_edges[0,1] != len_edges[1,1]):
        #     print("The number of falling edges detected for both robot are different")
        #     if len_edges[0,1] > len_edges[1,1]:
        #         min_diff_idx = np.argmin(np.diff(falling_edges_idx[0]))
        #         # look for the closest rising edges idx witht the other robot
        #         max_diff_idx = np.argmax([falling_edges_idx[0][min_diff_idx+ii] - falling_edges_idx[1][min_diff_idx] for ii in range(2)]) + min_diff_idx
        #         falling_edges_idx[0] = np.delete(falling_edges_idx[0], max_diff_idx)
        #     else:
        #         min_diff_idx = np.argmin(np.diff(falling_edges_idx[1]))
        #         # look for the closest rising edges idx witht the other robot
        #         max_diff_idx = np.argmax([falling_edges_idx[1][min_diff_idx+ii] - falling_edges_idx[0][min_diff_idx] for ii in range(2)]) + min_diff_idx
        #         falling_edges_idx[1] = np.delete(falling_edges_idx[1], max_diff_idx)

        # rising_edges_idx = np.array(rising_edges_idx)
        # falling_edges_idx = np.array(falling_edges_idx)
        # # both robots should return approximatly the same edges
        # if (np.abs(np.diff(rising_edges_idx, axis=0)) > 5).any():
        #     print("The rising edges of the step detected for both robot differs too much.")
        #     print(np.abs(np.diff(rising_edges_idx, axis=0)))
        # if (np.abs(np.diff(falling_edges_idx, axis=0)) > 5).any():
        #     print("The falling edges of the step detected for both robot differs too much.")
        #     print(np.abs(np.diff(falling_edges_idx, axis=0)))
        # # The min index of the rising edges, and max index of the falling indes are kept
        # rising_edges_idx = np.min(rising_edges_idx, axis=0)
        # falling_edges_idx = np.max(falling_edges_idx, axis=0)
        # # edges are regrouped 
        # if np.min(rising_edges_idx) < np.min(falling_edges_idx):
        #     edges_idx = np.sort(np.hstack((rising_edges_idx, falling_edges_idx)))
        # else:
        #     edges_idx = np.sort(np.hstack((falling_edges_idx, rising_edges_idx)))
        edges_idx = edges_idx_list[it]
        ######
        # Display reconstructed forces from joint torques
        if CHECK_RECONSTRUCTED_FORCES_ON:
            fig, axs = plt.subplots(2,3,sharex=True)
            plt.rcParams.update({'font.size': 14})
            for p, arm_id in enumerate(arm_ids):
                f_rec = merged_data[arm_id]['wrench_rec'][:3,:]
                for i, fi in enumerate(f_rec):
                    non_contact_rest_force = np.mean(fi[:500])
                    axs[p][i].plot(merged_data[arm_id]['t'], fi - non_contact_rest_force, color=color_list[0], linewidth=2)
                    if i == 2: # z axis
                        # idxs = get_step_edges(fi)
                        axs[p][i].plot(merged_data[arm_id]['t'][edges_idx], fi[edges_idx] - non_contact_rest_force, 'x', color='k')
            fig.suptitle('Reconstructed forces from joint torques')
        ######
        # Compute estimated deviation from stiffness matrices according to input force
        KP_list = np.array([KP_gain_list[it, 0]*np.eye(6), KP_gain_list[it, 1]*np.eye(6)])
        nb_samples = merged_data[list(merged_data.keys())[0]]['q'].shape[1]
        coupled_stiffness_mat = compute_coupled_stiffness_matrices(merged_data, pandas, KP_list)
        ## with assumed step force (20N)
        fi = np.array([0,0,20,0,0,0])
        f_ass = []
        deviation_from_assumed_force = []
        for i, coupled_stiffness in enumerate(coupled_stiffness_mat):
            # only the first step is considered
            if (i >= edges_idx[0] and i <= edges_idx[1]):
                deviation_from_assumed_force.append(np.linalg.inv(coupled_stiffness) @ fi)
                f_ass.append(fi)
            else:
                deviation_from_assumed_force.append(np.zeros((6)))
                f_ass.append(np.zeros((6)))
        f_ass = np.array(f_ass).T
        deviation_from_assumed_force = np.array(deviation_from_assumed_force).T
        ## with summed forces 
        deviation_from_summed_force = []
        f_sum = np.zeros((6,nb_samples))
        for data in merged_data.values():
            f_sum = f_sum + data['wrench_rec_wo_serr']
        f_sum = np.array(f_sum)
        for coupled_stiffness, fi in zip(coupled_stiffness_mat, f_sum.T):
            deviation_from_summed_force.append(np.linalg.inv(coupled_stiffness) @ fi)
        deviation_from_summed_force = np.array(deviation_from_summed_force).T
        ## individually, using estimated force from torques for each robots 
        deviation_for_individual_robots = []
        for p, (panda, arm_id) in enumerate(zip(pandas,arm_ids)):
            dev_tmp = compute_static_error(merged_data[arm_id], panda, KP_list[p])
            deviation_for_individual_robots.append([dev_tmp_i - np.mean(dev_tmp_i[:500]) for dev_tmp_i in dev_tmp])
        deviation_for_individual_robots = np.array(deviation_for_individual_robots)
        ######
        # Display the estimated deviations
        if CHECK_ALL_AXIS_DEVIATION_ON:
            fig = plt.figure(layout='constrained', figsize=(15, 8))
            fig.suptitle('Panda Kp gains (p1,p2) : ({},{})'.format(KP_gain_list[it, 0], KP_gain_list[it, 1]))
            subfigs = fig.subfigures(2, 1, wspace=0.07)
            # position
            axsUp = subfigs[0].subplots(1, 3, sharex=True, sharey=True)
            for i, (eps_ass_i, eps_sum_i) in enumerate(zip(deviation_from_assumed_force[:3,:], deviation_from_summed_force[:3,:])):
                axsUp[i].yaxis.set_major_formatter(tck.FuncFormatter(lambda x, pos: '{0:g}'.format(x*1000)))
                axsUp[i].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], eps_ass_i[edges_idx[0]-100:edges_idx[1]+100], color=color_list[0], linewidth=2, alpha=0.8, label='$d_x (f^*)$')
                axsUp[i].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], eps_sum_i[edges_idx[0]-100:edges_idx[1]+100], color=color_list[1], linewidth=2, alpha=0.8, label=r'$d_x (\sum J^{-t}\tau)$')
                # axsUp[i].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], deviation_for_individual_robots[0,i,edges_idx[0]-100:edges_idx[1]+100], color=color_list[2], linewidth=1, alpha=0.8, label=r'$d_x (J^{-t}\tau^{p_1})$')
                # axsUp[i].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], deviation_for_individual_robots[1,i,edges_idx[0]-100:edges_idx[1]+100], color=color_list[3], linewidth=1, alpha=0.8, label=r'$d_x (J^{-t}\tau^{p_2})$')
                for p, arm_id in enumerate(arm_ids):
                    axsUp[i].plot(merged_data[arm_id]['t'][edges_idx[0]-100:edges_idx[1]+100], deviation_for_individual_robots[p,i,edges_idx[0]-100:edges_idx[1]+100], color=color_list[2+p], linewidth=1, alpha=0.8, label=r'$d_x (J^{{-t}}\tau^{{p_{}}})$'.format(p+1))
                    axsUp[i].plot(merged_data[arm_id]['t'][edges_idx[0]-100:edges_idx[1]+100], merged_data[arm_id]['deviation_wo_serr'][i,edges_idx[0]-100:edges_idx[1]+100], color=color_list[2+p], linestyle='dashed', linewidth=1.5, label='$d_x(p_'+str(p+1)+')$')
            axsUp[0].legend()
            # force
            subfigs[0].suptitle('Pose deviations (mm)', fontsize='x-large')
            axsDw = subfigs[1].subplots(1, 3, sharex=True, sharey=True)
            for i, (f_ass_i, f_sum_i) in enumerate(zip(f_ass[:3], f_sum[:3])):
                axsDw[i].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], f_ass_i[edges_idx[0]-100:edges_idx[1]+100], color=color_list[0], linewidth=2, alpha=0.8, label='$f^*$')
                axsDw[i].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], f_sum_i[edges_idx[0]-100:edges_idx[1]+100], color=color_list[1], linewidth=2, alpha=0.8, label=r'$\Sigma J^{-t}\tau$')
                for p, arm_id in enumerate(arm_ids):
                    axsDw[i].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], merged_data[arm_id]['wrench_rec_wo_serr'][i,edges_idx[0]-100:edges_idx[1]+100], color=color_list[p+2], linewidth=1, alpha=0.8, label=r'$d_x (J^{{-t}}\tau^{{ p_{} }})$'.format(p+1)) #r'$d_x (J^{-t}\tau^{p_{}})$'.format(p+1)
            axsDw[0].legend()
            subfigs[1].suptitle('External force (N)', fontsize='x-large')
        ## NORM
        if CHECK_NORM_DEVIATION_ON:
            fig, axs = plt.subplots(2,1,sharex=True,layout='constrained', figsize=(15, 8))
            fig.suptitle('Panda Kp gains (p1,p2) : ({},{})'.format(KP_gain_list[it, 0], KP_gain_list[it, 1]))
            # position
            axs[0].yaxis.set_major_formatter(tck.FuncFormatter(lambda x, pos: '{0:g}'.format(x*1000)))
            axs[0].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], np.linalg.norm(deviation_from_assumed_force[:3,edges_idx[0]-100:edges_idx[1]+100], axis=0), color=color_list[0], linewidth=2, alpha=0.8, label='$d_x (f^*)$')
            axs[0].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], np.linalg.norm(deviation_from_summed_force[:3,edges_idx[0]-100:edges_idx[1]+100], axis=0), color=color_list[1], linewidth=1, alpha=0.8, label=r'$d_x (\sum J^{-t}\tau)$')
            for p, arm_id in enumerate(arm_ids):
                axs[0].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], np.linalg.norm(deviation_for_individual_robots[p,:3,edges_idx[0]-100:edges_idx[1]+100], axis=0), color=color_list[2+p], linewidth=1, alpha=0.8, label=r'$d_x (J^{{-t}}\tau^{{p_{}}})$'.format(p+1)) # estimation
                axs[0].plot(merged_data[arm_id]['t'][edges_idx[0]-100:edges_idx[1]+100], np.linalg.norm(merged_data[arm_id]['deviation_wo_serr'][:3,edges_idx[0]-100:edges_idx[1]+100], axis=0), color=color_list[2+p], linestyle='dashed', linewidth=1.5, label='$d_x(p_'+str(p+1)+')$') # measure
            axs[0].legend()
            axs[0].set_title('Pose deviations norm (mm)', fontsize='x-large')
            # force
            axs[1].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], np.linalg.norm(f_ass[:3,edges_idx[0]-100:edges_idx[1]+100], axis=0), color=color_list[0], linewidth=2, alpha=0.8, label='$f^*$')
            axs[1].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], np.linalg.norm(f_sum[:3,edges_idx[0]-100:edges_idx[1]+100], axis=0), color=color_list[1], linewidth=1, alpha=0.8, label=r'$\Sigma J^{-t}\tau$')
            for p, arm_id in enumerate(arm_ids):
                axs[1].plot(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100], np.linalg.norm(merged_data[arm_id]['wrench_rec_wo_serr'][:3,edges_idx[0]-100:edges_idx[1]+100], axis=0), color=color_list[p+2], linewidth=1, alpha=0.8, label=r'$d_x (J^{{-t}}\tau^{{ p_{} }})$'.format(p+1)) #r'$d_x (J^{-t}\tau^{p_{}})$'.format(p+1)
            axs[1].legend()
            axs[1].set_title('External force norm (N)', fontsize='x-large')
        ######
        # Estimation errors computation
        ## Error between the measured endpoints and the estimated endpoints 
        ## For each robots
        meas_dev = []
        estim_dev = []
        for p, arm_id in enumerate(arm_ids):
            estim_dev.append( np.linalg.norm(deviation_for_individual_robots[p,:3,edges_idx[0]+100:edges_idx[1]-100], axis=0) )
            meas_dev.append( np.linalg.norm(merged_data[arm_id]['deviation_wo_serr'][:3,edges_idx[0]+100:edges_idx[1]-100], axis=0) )
        #
        dev_err_robots = np.array(estim_dev) - np.array(meas_dev)
        # fig, ax = plt.subplots(1,1,sharex=True,layout='constrained')
        # for p, arm_id in enumerate(arm_ids):
        #     ax.plot(merged_data[arm_ids[0]]['t'][edges_idx[0]+100:edges_idx[1]-100], dev_err_robots[p])

        mean_dev_err_robots = np.mean(dev_err_robots, axis=1)
        print("Mean errors of panda 1: {}mm, panda 2: {}mm".format(mean_dev_err_robots[0]*1000, mean_dev_err_robots[1]*1000))

        mean_dev = np.mean(meas_dev, axis=0)
        estim_global_dev = np.linalg.norm(deviation_from_summed_force[:3,edges_idx[0]+100:edges_idx[1]-100], axis=0)
        dev_err_robots_middle = estim_global_dev - mean_dev
        mean_dev_err_robots_middle.append( np.mean(dev_err_robots_middle) )
        print("Mean error of panda middle point: {}mm".format(mean_dev_err_robots_middle[-1]*1000))

        data = []
        data.append(merged_data[arm_ids[0]]['t'][edges_idx[0]-100:edges_idx[1]+100])
        data.append(np.linalg.norm(f_sum[:3,edges_idx[0]-100:edges_idx[1]+100], axis=0))
        data.append(np.linalg.norm(merged_data[arm_ids[0]]['wrench_rec_wo_serr'][:3,edges_idx[0]-100:edges_idx[1]+100], axis=0))
        data.append(np.linalg.norm(merged_data[arm_ids[1]]['wrench_rec_wo_serr'][:3,edges_idx[0]-100:edges_idx[1]+100], axis=0))
        data.append(np.mean([np.linalg.norm(merged_data[arm_ids[0]]['deviation_wo_serr'][:3,edges_idx[0]-100:edges_idx[1]+100], axis=0),
                     np.linalg.norm(merged_data[arm_ids[1]]['deviation_wo_serr'][:3,edges_idx[0]-100:edges_idx[1]+100], axis=0)], axis=0))
        data.append(np.linalg.norm(deviation_from_summed_force[:3,edges_idx[0]-100:edges_idx[1]+100], axis=0))
        data = np.array(data)
        headers = ",".join(['t'+',tot_f'+',p1_f'+',p2_f'+',meas_dev'+',pred_dev'])
        # np.savetxt(bag_directories[sess][27:-1]+bag_names_list[sess][it][11:-24] + ".csv", data.T, delimiter=',', header=headers, comments='')
# %%